| Home | Libraries | People | FAQ | More

##### flat_stream::async_read_some

Start an asynchronous read.

###### Synopsis

    template<
        class MutableBufferSequence,
        class ReadHandler>
    async_read_some(
        MutableBufferSequence const& buffers,
        ReadHandler&& handler);

###### Description

This function is used to asynchronously read one or more bytes of data from the stream. The function call always returns immediately.

###### Parameters

Name | Description
--- | ---
`buffers` | The buffers into which the data will be read. Although the buffers object may be copied as necessary, ownership of the underlying buffers is retained by the caller, which must guarantee that they remain valid until the handler is called.

`handler`

The completion handler to invoke when the operation completes. The implementation takes ownership of the handler by performing a decay-copy. The equivalent function signature of the handler must be:

    void handler(
        error_code const& error,        // Result of operation.
        std::size_t bytes_transferred   // Number of bytes read.
    );

Regardless of whether the asynchronous operation completes immediately or not, the handler will not be invoked from within this function. Invocation of the handler will be performed in a manner equivalent to using `net::post`.

###### Remarks

The `read_some` operation may not read all of the requested number of bytes. Consider using the function `net::async_read` if you need to ensure that the requested amount of data is read before the asynchronous operation completes.